function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useReducer, useLayoutEffect } from "preact/compat";
var CLASS_NAME = 'ds--dialog-open';
var PROPERTY_NAME = '--body_top--dialog-open';
var OPEN = function OPEN(_state) {
  var _window$scrollY;
  // https://css-tricks.com/prevent-page-scrolling-when-a-modal-is-open/
  var y = (_window$scrollY = window.scrollY) !== null && _window$scrollY !== void 0 ? _window$scrollY : 0;
  document.body.classList.add(CLASS_NAME);
  document.body.style.setProperty(PROPERTY_NAME, "-".concat(y, "px"));
  document.documentElement.style.setProperty('scroll-behavior', 'auto');
  return {
    name: 'open',
    bodyScrollY: y
  };
};
var CLOSE = function CLOSE(state) {
  document.body.classList.remove(CLASS_NAME);
  document.body.style.removeProperty(PROPERTY_NAME);
  window.scrollTo({
    top: state.bodyScrollY,
    behavior: 'auto'
  });
  document.documentElement.style.removeProperty('scroll-behavior');
  return {
    name: 'closed'
  };
};
var reducer = function reducer(state, transition) {
  if (state.name === 'open' && transition === CLOSE) {
    return transition(state);
  } else if (state.name === 'closed' && transition === OPEN) {
    return transition(state);
  }
  return state;
};

/**
 * Prevents scrolling the page behind the dialog
 */
export function useBodyScrollPrevention(isOpen) {
  var _useReducer = useReducer(reducer, {
      name: 'closed'
    }),
    _useReducer2 = _slicedToArray(_useReducer, 2),
    _state = _useReducer2[0],
    dispatch = _useReducer2[1];
  // Needs to use useLayoutEffect because we need to grab the window scroll position
  // before the dialog renders and messes it up.
  useLayoutEffect(function () {
    dispatch(isOpen ? OPEN : CLOSE);
  }, [isOpen]);
}